
' ============================================================================
' XAV Stats script, by Liron Newman (plastish at ultinet dot org)
'
' Version 1.1, 4-Feb-2004
'
' URL: http://www.eesh.net/XAVStats.zip
' ============================================================================
'
' Commandline Syntax:
' 
' CScript.exe XAVStats.vbs < c:\xav\xav.log
'
' * Note the fact that the logfile should be redirected to the script's StdIn!
'
' All output is directed to the StdOut.
'
' Alternatively, you can also run the script directly and get a box asking for
' a log filename, drag & drop the logfile on the script in the Windows Explorer
' or just Start=>Run: c:\xav\XAVStats.vbs c:\xav\xav.log
'
' These last options will bring the output in a messagebox rather than to the
' StdOut.
'
' DISCLAIMER: This script is free, do whatever you want with it, just please
' give me credit. I (the author) do not take any responsibility for any kind
' of damage or problems that may occur to you or your property when using this
' script or anything associated with it.
' ============================================================================

'Handler for WScript.exe usage:
If UCase(Right(WScript.FullName, 11)) = "WSCRIPT.EXE" Then
    On Error Resume Next

    Dim WshShell, oExec, WinTitle, LogPath

    WinTitle="XAVStats v1.1 by Liron Newman"

    Set WshShell = CreateObject("WScript.Shell")

    If WScript.Arguments.Count > 0 Then
        LogPath = WScript.Arguments(0)
    Else
        LogPath = InputBox("Enter the path to XAV.LOG:", WinTitle, "c:\xav\xav.log")
        If LogPath = "" Then WScript.Quit
    End If

    Set oExec = WshShell.Exec(WshShell.ExpandEnvironmentStrings("%COMSPEC%") & " /c CScript.exe " & WScript.ScriptFullName & "<" & LogPath)

    Do While oExec.Status = 0
        WScript.Sleep 100
    Loop

    oExec.StdOut.SkipLine
    oExec.StdOut.SkipLine
    oExec.StdOut.SkipLine

    MsgBox Replace(oExec.StdOut.ReadAll, "Done.", "") & vbNewLine & "This script can also be executed from the commandline," & vbNewLine & "view its body for details.", vbInformation, WinTitle

    WScript.Quit

End If

'Handler ended, if we got here - The script run with CScript.

Dim AddrArrNum(), AddrArrAddr()
'Sub Main... :)
    ReDim AddrArrAddr(0)
    ReDim AddrArrNum(0)
    Dim txt, DaysRunning, Counter
    If Not WScript.StdIn.AtEndOfStream Then
        txt = WScript.StdIn.ReadLine
        DaysRunning = DateDiff("d", Mid(txt, 2, 19), Now)
        AddToResults "XAV running for " & DaysRunning & " days."
    End If
    Counter = 2
    Do
        AddToAddrArr Mid(txt, InStr(txt, "RCPT=[") + 5)
        txt = WScript.StdIn.ReadLine
        Counter = Counter + 1
    Loop Until WScript.StdIn.AtEndOfStream
    AddToResults ""
    AddToResults "Stopped " & Counter & " viral messages to " & UBound(AddrArrAddr) & " recipients."
    AddToResults "On average, that's " & Round(Counter / DaysRunning, 2) & " messages per day, and " & Round(Counter / UBound(AddrArrAddr), 2) & " messages per recipient."
    Dim x, HighestMsgNum, HighestRecNum
    For x = LBound(AddrArrAddr) To UBound(AddrArrAddr)
        If AddrArrNum(x) > HighestMsgNum Then
            HighestMsgNum = AddrArrNum(x)
            HighestRecNum = x
        End If
    Next
    AddToResults ""
    AddToResults "Unluckiest recipient: " & AddrArrAddr(HighestRecNum) & " with " & HighestMsgNum & " messages!"
    AddToResults ""
    AddToResults "Done."
'End Sub Main

Sub AddToAddrArr(NewAddr)
    Dim x, Found
    Found = False
    For x = LBound(AddrArrAddr) To UBound(AddrArrAddr)
        If AddrArrAddr(x) = NewAddr Then
            AddrArrNum(x) = AddrArrNum(x) + 1
            Found = True
            Exit For
        End If
    Next
    If Found = False Then
        ReDim Preserve AddrArrAddr(UBound(AddrArrAddr) + 1)
        ReDim Preserve AddrArrNum(UBound(AddrArrNum) + 1)
        AddrArrAddr(UBound(AddrArrAddr)) = NewAddr
        AddrArrNum(UBound(AddrArrNum)) = 1
    End If
End Sub

Sub AddToResults(str)
    'Results.Text = Results.Text & str & vbNewLine
    'Results.Refresh
    'Refresh
    WScript.StdOut.Write str & vbNewLine
End Sub
